<nb-card>
  <nb-card-header>
    Edit profile
  </nb-card-header>
  <nb-card-body [nbSpinner]="loading" nbSpinnerMessage="Saving...">
    <form [formGroup]="form">
      <div class="form-group">
        <label class="label" for="name">Name:</label>
        <input id="name" class="form-control" fullWidth nbInput formControlName="name" [ngClass]="{'is-invalid': hasError('name')}"/>

        <div class="invalid-feedback mt-2" *ngIf="hasError('name')">
          <span *ngIf="form.controls.name.errors.required">Field is required</span>
          <span *ngIf="form.controls.name.errors.minlength">Min. length is 3</span>
          <span *ngIf="form.controls.name.errors.maxlength">Max. length is 50</span>
        </div>
      </div>

      <div class="form-group">
        <label class="label" for="price">Price:</label>
        <input id="price" class="form-control" type="number" fullWidth nbInput formControlName="price" [ngClass]="{'is-invalid': hasError('price')}"/>

        <div class="invalid-feedback mt-2" *ngIf="hasError('price')">
          <span *ngIf="form.controls.price.errors.required">Field is required</span>
          <span *ngIf="form.controls.price.errors.minlength">Min price is $1</span>
          <span *ngIf="form.controls.price.errors.maxlength">Max price is $100</span>
        </div>
      </div>

      <div class="form-group">
        <label class="label" for="description">Description:</label>
        <textarea id="description" class="form-control" fullWidth nbInput formControlName="description" [ngClass]="{'is-invalid': hasError('description')}"></textarea>

        <div class="invalid-feedback mt-2" *ngIf="hasError('description')">
          <span *ngIf="form.controls.description.errors.required">Field is required</span>
          <span *ngIf="form.controls.description.errors.minlength">Min. length is 20</span>
          <span *ngIf="form.controls.description.errors.maxlength">Max. length is 200</span>
        </div>
      </div>

      <div class="form-group d-flex flex-column" *ngIf="categoryOptions?.length">
        <label class="label" for="categoryId">Category:</label>
        <nb-select id="categoryId"
                   fullWidth
                   formControlName="categoryId"
                   [ngClass]="{'is-invalid': hasError('categoryId')}">
          <nb-option *ngFor="let category of categoryOptions" [value]="category.id">
            {{ category.title }}
          </nb-option>
        </nb-select>

        <div class="invalid-feedback mt-2" *ngIf="hasError('categoryId')">
          <span *ngIf="form.controls.categoryId.errors.required">Field is required</span>
        </div>
      </div>

      <div class="form-group">
        <label class="label" for="imgUrl">Image URL:</label>
        <input id="imgUrl" class="form-control" fullWidth nbInput formControlName="imgUrl" [ngClass]="{'is-invalid': hasError('imgUrl')}"/>

        <div class="invalid-feedback mt-2" *ngIf="hasError('imgUrl')">
          <span *ngIf="form.controls.imgUrl.errors.required">Field is required</span>
          <span *ngIf="form.controls.imgUrl.errors.pattern">Invalid URL</span>
        </div>
      </div>

      <div class="img" *ngIf="!hasError('imgUrl') && form.controls?.imgUrl?.value">
        <div class="image" [ngStyle]="{'background-image': 'url(' + form.controls?.imgUrl?.value + ')'}"></div>
      </div>
    </form>
  </nb-card-body>
  <nb-card-footer class="d-flex justify-content-between">
    <button nbButton ghost status="warning" (click)="cancel()">Cancel</button>
    <button nbButton ghost status="success" (click)="save()" [disabled]="!form.valid">Save</button>
  </nb-card-footer>
</nb-card>
